<template>
  <v-card flat dense>
    <v-card-text class="pt-0 pb-0">
    This project search is filtered on only projects where you are a member. The dropdown shows a max of 20 matching items.
      <v-autocomplete
          clearable
          height=65
          v-model="model"
          :items="items"
          :filter="() => true"
          :loading="isLoading"
          :search-input.sync="search"
          hide-no-data
          color="black"
          item-text="name"
          item-value="id"
          label="Search by project name, ID or URL"
          return-object
      >
        <template v-slot:selection="data">
          <v-list-item-avatar size=40>
            <img v-if="data.item.avatar_url != null" :src="data.item.avatar_url">
          </v-list-item-avatar>
          <v-list-item-content>
            <v-list-item-title v-html="data.item.name"></v-list-item-title>
            <v-list-item-subtitle v-html="data.item.name_with_namespace"></v-list-item-subtitle>
          </v-list-item-content>
        </template>
        <template v-slot:item="data">
          <template>
            <v-list-item-avatar>
              <img v-if="data.item.avatar_url != null" :src="data.item.avatar_url">
            </v-list-item-avatar>
            <v-list-item-content>
              <v-list-item-title v-html="data.item.name"></v-list-item-title>
              <v-list-item-subtitle v-html="data.item.name_with_namespace"></v-list-item-subtitle>
            </v-list-item-content>
          </template>
        </template>
      </v-autocomplete>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator'
import { State, Action } from 'vuex-class'
import * as GitLabHelper from '../gitlab'
import log from 'loglevel'

@Component
export default class ProjectSelector extends Vue {
    descriptionLimit = 60
    count = 0
    entries:any[] = []
    isLoading = false
    model:any = null
    search = ''
    meteredSearch = ''
    timeout: any
    baseUrl = GitLabHelper.getHost()
    items: any[] = []

    @State project!: Record<string, string>
    @State token!: string
    @Action setProject: any
    @Action setScope: any

    activated (): void {
      if (this.project) {
        this.model = this.project
      } else {
        this.findProjects()
      }
    }

    @Watch('search')
    meteredUpdateSearch (): void {
      clearTimeout(this.timeout)
      this.timeout = setTimeout(() => {
        this.meteredSearch = this.search
      }, 500)
    }

    @Watch('entries')
    loadItems (): void {
      this.items = this.entries.map(entry => {
        try {
          const name = entry.name.length > this.descriptionLimit
            ? entry.name.slice(0, this.descriptionLimit) + '...'
            : entry.name

          return Object.assign({}, entry, { name })
        } catch (err) {
          log.error(err)
          log.error(entry)
        }
      })
    }

    @Watch('model')
    selectProject (): void {
      this.setProject(this.model)
      this.setScope({ scope: null, scopeType: null })
    }

    @Watch('meteredSearch')
    findProjects (): void {
      if (!this.search) return
      const api = GitLabHelper.getAPI()
      if (this.search?.indexOf('/') >= 0 || /^\d+$/.test(this.search.trim())) {
        this.isLoading = true
        const projectRef = this.search.trim().replace(this.baseUrl, '').replace('/^//g', '').replace('///g', '%2f')
        api.Projects
          .show(projectRef)
          .then((result) => {
            const project: any = Array.isArray(result) ? result[0] : result

            if (project.permissions?.project_access?.access_level > 10 || project.permissions?.group_access?.access_level > 10) {
              this.model = project
              this.entries = [project]
            }
          })
          .finally(() => { this.isLoading = false })
      } else {
        if ((this.search?.length > 0 && this.search?.length < 3) || this.isLoading || this.model?.name === this.search) return
        this.isLoading = true
        api.Projects
          .search(this.search, { maxPages: 2, membership: true, min_access_level: 10, search_namespaces: true })
          .then((result) => {
            this.entries = Array.isArray(result) ? result : [result]
          })
          .finally(() => { this.isLoading = false })
      }
    }
}

</script>
